(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else {
		var a = factory();
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var tarjan_1 = __webpack_require__(1);
var bundle_tree_1 = __webpack_require__(2);
var neighbors_list_1 = __webpack_require__(4);
var trimGraph = function (graph) {
    var minEdge = Infinity;
    Object.keys(graph).forEach(function (k) {
        Object.keys(graph[k]).forEach(function (n) {
            if (graph[k][n] < minEdge && graph[k][n] > 0) {
                minEdge = graph[k][n];
            }
        });
    });
    Object.keys(graph).forEach(function (k) {
        Object.keys(graph[k]).forEach(function (n) {
            graph[k][n] = Math.max(graph[k][n] - minEdge, 0);
        });
    });
};
// Turn into a Markov chain
var normalize = function (graph) {
    Object.keys(graph).forEach(function (k) {
        var ns = Object.keys(graph[k]);
        var total = ns.reduce(function (a, c) { return a + graph[k][c]; }, 0);
        ns.forEach(function (n) { return (graph[k][n] = graph[k][n] / total); });
    });
    // Cut pages such as:
    // - a -> b, 50%
    // - b -> a, 1%
    // Then we don't want to let `a` and `b` belong to the same bundle.
    Object.keys(graph).forEach(function (k) {
        Object.keys(graph[k]).forEach(function (n) {
            if (graph[k][n] < 0.05 || !graph[n] || !graph[n][k] || graph[n][k] < 0.05) {
                graph[k][n] = 0;
                if (graph[n] && graph[n][k]) {
                    graph[n][k] = 0;
                }
            }
        });
    });
};
var normalizeEntryPoints = function (cluster, tree, pathCluster, entryPointModule) {
    var changed = false;
    try {
        for (var cluster_1 = __values(cluster), cluster_1_1 = cluster_1.next(); !cluster_1_1.done; cluster_1_1 = cluster_1.next()) {
            var a = cluster_1_1.value;
            try {
                for (var cluster_2 = __values(cluster), cluster_2_1 = cluster_2.next(); !cluster_2_1.done; cluster_2_1 = cluster_2.next()) {
                    var b = cluster_2_1.value;
                    if (a === b) {
                        continue;
                    }
                    // We can keep sibings in the same chunk
                    var nodeA = tree.find(entryPointModule[a].modulePath);
                    var nodeB = tree.find(entryPointModule[b].modulePath);
                    if (nodeA.parent === nodeB.parent) {
                        continue;
                    }
                    var ancestor = tree.lca(entryPointModule[a], entryPointModule[b]);
                    if (!ancestor) {
                        throw new Error('Cannot find LCA');
                    }
                    var entry = ancestor[0].modulePath;
                    if (cluster.indexOf(entry) < 0) {
                        while ((pathCluster[entry] || []).length) {
                            cluster.push(pathCluster[entry].pop());
                            changed = true;
                        }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (cluster_2_1 && !cluster_2_1.done && (_a = cluster_2.return)) _a.call(cluster_2);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (cluster_1_1 && !cluster_1_1.done && (_b = cluster_1.return)) _b.call(cluster_1);
        }
        finally { if (e_2) throw e_2.error; }
    }
    if (changed) {
        normalizeEntryPoints(cluster, tree, pathCluster, entryPointModule);
    }
    var e_2, _b, e_1, _a;
};
exports.clusterize = function (bundleGraph, modules, n) {
    if (n <= 0) {
        throw new Error('The number of bundles should be a positive number');
    }
    var nodes = new Set();
    Object.keys(bundleGraph).forEach(function (k) {
        nodes.add(k);
        Object.keys(bundleGraph[k]).forEach(function (n) {
            nodes.add(n);
        });
    });
    if (n > nodes.size) {
        throw new Error('The number of clusters should be smaller or equal to the number of modules');
    }
    if (n === nodes.size) {
        var result = [];
        try {
            for (var _a = __values(nodes.values()), _b = _a.next(); !_b.done; _b = _a.next()) {
                var r = _b.value;
                result.push([r]);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return result;
    }
    if (n === 1) {
        var cluster = [];
        try {
            for (var _d = __values(nodes.values()), _e = _d.next(); !_e.done; _e = _d.next()) {
                var r = _e.value;
                cluster.push(r);
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_4) throw e_4.error; }
        }
        return [cluster];
    }
    // Build a Markov chain
    // normalize(bundleGraph);
    // Each node in the bundle tree is an entry point of a bundle.
    // The node contains all the routes defined in this entry point.
    var bundleTree = new bundle_tree_1.BundleTree();
    bundleTree.build(modules);
    // Path to module mapping
    var entryPointModule = {};
    modules.forEach(function (m) {
        entryPointModule[m.modulePath] = m;
    });
    var _loop_1 = function () {
        // Build the neighbors list in the current version of the graph.
        var nl = neighbors_list_1.neighborsList(bundleGraph, nodes);
        // Find the connected components.
        var cc = tarjan_1.tarjan(nl);
        // Each node in each connected component should point to
        // the connected component itself.
        // Two nodes from the same connected component should point to the same reference.
        var bundleClusterMap = {};
        cc.forEach(function (c) {
            try {
                for (var c_1 = __values(c), c_1_1 = c_1.next(); !c_1_1.done; c_1_1 = c_1.next()) {
                    var n_1 = c_1_1.value;
                    bundleClusterMap[n_1] = c;
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (c_1_1 && !c_1_1.done && (_a = c_1.return)) _a.call(c_1);
                }
                finally { if (e_5) throw e_5.error; }
            }
            var e_5, _a;
        });
        // For each connected component, we want to push all the parents of all the routes.
        // For example, if the user wants to load `/a/b/c` from `/d`, this means
        // that if `/a/b/c` & `/d` are in the same connected component, we should also
        // push `/a` and `/a/b` because without them we cannot provide `/a/b/c`.
        cc.forEach(function (c) {
            normalizeEntryPoints(c, bundleTree, bundleClusterMap, entryPointModule);
        });
        // Drop all the empty connected components.
        var res = cc.filter(function (c) { return c.length; });
        if (res.length >= n) {
            return { value: res };
        }
        // Trim the graph if we haven't found a solution yet.
        trimGraph(bundleGraph);
    };
    while (true) {
        var state_1 = _loop_1();
        if (typeof state_1 === "object")
            return state_1.value;
    }
    var e_3, _c, e_4, _f;
};


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.tarjan = function (graph) {
    graph = graph || {};
    var indexes = {};
    var lowIndexes = {};
    var onStack = {};
    var result = [];
    var stack = [];
    var index = 1;
    var connectedComponent = function (node) {
        stack.push(node);
        onStack[node] = true;
        indexes[node] = index;
        lowIndexes[node] = index;
        index += 1;
        graph[node].forEach(function (n) {
            if (indexes[n] === undefined) {
                connectedComponent(n);
                lowIndexes[node] = Math.min(lowIndexes[n], lowIndexes[node]);
            }
            else if (onStack[n]) {
                lowIndexes[node] = Math.min(lowIndexes[node], indexes[n]);
            }
        });
        // This is a "root" node
        var cc = [];
        if (indexes[node] === lowIndexes[node]) {
            var current = void 0;
            do {
                current = stack.pop();
                onStack[current] = false;
                cc.push(current);
            } while (stack.length > 0 && node !== current);
            result.push(cc);
        }
    };
    Object.keys(graph).forEach(function (n) {
        if (!indexes[n]) {
            connectedComponent(n);
        }
    });
    return result;
};


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var topological_sort_1 = __webpack_require__(3);
var BundleNode = /** @class */ (function () {
    function BundleNode(key, parent) {
        this.key = key;
        this.parent = parent;
        this.defs = [];
        this.children = {};
    }
    return BundleNode;
}());
exports.BundleNode = BundleNode;
var BundleTree = /** @class */ (function () {
    function BundleTree() {
        this.root = null;
    }
    BundleTree.prototype.build = function (m) {
        var roots = m.filter(function (c) { return !c.parentModulePath; });
        if (roots.length !== 1) {
            throw new Error('One root module allowed');
        }
        var root = roots[0];
        this.root = new BundleNode(root.modulePath, null);
        this.root.defs.push(root);
        m = m.filter(function (c) { return c.parentModulePath; });
        // Build neighbors list
        var graph = {};
        try {
            for (var m_1 = __values(m), m_1_1 = m_1.next(); !m_1_1.done; m_1_1 = m_1.next()) {
                var c = m_1_1.value;
                graph[c.modulePath] = [];
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (m_1_1 && !m_1_1.done && (_a = m_1.return)) _a.call(m_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var moduleMap = {};
        try {
            for (var m_2 = __values(m), m_2_1 = m_2.next(); !m_2_1.done; m_2_1 = m_2.next()) {
                var c = m_2_1.value;
                if (c.parentModulePath !== root.modulePath) {
                    graph[c.parentModulePath].push(c.modulePath);
                }
                moduleMap[c.modulePath] = moduleMap[c.modulePath] || [];
                moduleMap[c.modulePath].push(c);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (m_2_1 && !m_2_1.done && (_b = m_2.return)) _b.call(m_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
        // Remove duplicates
        Object.keys(graph).forEach(function (n) {
            graph[n] = graph[n].filter(function (e, i) { return graph[n].indexOf(e) === i; });
        });
        var insertionOrder = topological_sort_1.topologicalSort(graph);
        var _loop_1 = function (c) {
            var parentEntry = moduleMap[c][0].parentModulePath;
            var parent_1 = this_1.find(parentEntry);
            if (!parent_1) {
                throw new Error("Cannot find parent bundle for " + c);
            }
            var node = parent_1.children[c] || new BundleNode(c, parent_1);
            moduleMap[c].forEach(function (m) { return node.defs.push(m); });
            parent_1.children[c] = node;
        };
        var this_1 = this;
        try {
            for (var insertionOrder_1 = __values(insertionOrder), insertionOrder_1_1 = insertionOrder_1.next(); !insertionOrder_1_1.done; insertionOrder_1_1 = insertionOrder_1.next()) {
                var c = insertionOrder_1_1.value;
                _loop_1(c);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (insertionOrder_1_1 && !insertionOrder_1_1.done && (_c = insertionOrder_1.return)) _c.call(insertionOrder_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        var e_1, _a, e_2, _b, e_3, _c;
    };
    BundleTree.prototype.lca = function (a, b) {
        var na = this.find(a.modulePath);
        var nb = this.find(b.modulePath);
        if (!na || !nb) {
            return null;
        }
        var visited = {};
        var nodeA = na;
        while (nodeA) {
            visited[nodeA.key] = true;
            nodeA = nodeA.parent;
        }
        var nodeB = nb;
        while (nodeB) {
            if (visited[nodeB.key]) {
                return nodeB.defs;
            }
            visited[nodeB.key] = true;
            nodeB = nodeB.parent;
        }
        nodeA = na;
        while (nodeA) {
            if (visited[nodeA.key]) {
                return nodeA.defs;
            }
            nodeA = nodeA.parent;
        }
        return null;
    };
    BundleTree.prototype.find = function (node) {
        if (!this.root) {
            return null;
        }
        var stack = [this.root];
        var _loop_2 = function () {
            var c = stack.pop();
            if (c.key === node) {
                return { value: c };
            }
            Object.keys(c.children).forEach(function (k) {
                stack.push(c.children[k]);
            });
        };
        while (stack.length) {
            var state_1 = _loop_2();
            if (typeof state_1 === "object")
                return state_1.value;
        }
        return null;
    };
    return BundleTree;
}());
exports.BundleTree = BundleTree;


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.topologicalSort = (function () {
    function topologicalSortHelper(node, visited, temp, graph, result) {
        temp[node] = true;
        var neighbors = graph[node];
        for (var i = 0; i < neighbors.length; i += 1) {
            var n = neighbors[i];
            if (temp[n]) {
                throw new Error('The graph is not a DAG');
            }
            if (!visited[n]) {
                topologicalSortHelper(n, visited, temp, graph, result);
            }
        }
        temp[node] = false;
        visited[node] = true;
        result.push(node);
    }
    return function (graph) {
        var result = [];
        var visited = {};
        var temp = {};
        for (var node in graph) {
            if (!visited[node] && !temp[node]) {
                topologicalSortHelper(node, visited, temp, graph, result);
            }
        }
        return result.reverse();
    };
})();


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var connected = function (a, b, graph) {
    return (graph[a] && graph[a][b] && graph[a][b] > 0) || (graph[b] && graph[b][a] && graph[b][a] > 0);
};
exports.neighborsList = function (graph, nodes) {
    var nl = {};
    try {
        for (var _a = __values(nodes.values()), _b = _a.next(); !_b.done; _b = _a.next()) {
            var a = _b.value;
            nl[a] = [];
            try {
                for (var _c = __values(nodes.values()), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    if (a === b) {
                        continue;
                    }
                    if (connected(a, b, graph)) {
                        nl[a].push(b);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_e = _c.return)) _e.call(_c);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_b && !_b.done && (_f = _a.return)) _f.call(_a);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return nl;
    var e_2, _f, e_1, _e;
};


/***/ })
/******/ ]);
});